Index: /palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1014)
+++ /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! OpenACC statements added
 !
 ! Former revisions:
@@ -65,6 +65,11 @@
 
     INTEGER ::  i, j, k
+    LOGICAL ::  coupled_run
     REAL    ::  a, b, e_q, rifm, uv_total, z_p
 
+!
+!-- Data information for accelerators
+    !$acc data present( e, nzb_u_inner, nzb_v_inner, nzb_s_inner, pt, q, qs ) &
+    !$acc      present( qsws, rif, shf, ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h )
 ! 
 !-- Compute theta*
@@ -74,4 +79,5 @@
 !--    for u* use the value from the previous time step
        !$OMP PARALLEL DO
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -90,4 +96,5 @@
 !--    (the Richardson number is still the one from the previous time step)
        !$OMP PARALLEL DO PRIVATE( a, b, k, z_p )
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -122,4 +129,5 @@
     IF ( .NOT. humidity )  THEN
        !$OMP PARALLEL DO PRIVATE( k, z_p )
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -140,4 +148,5 @@
     ELSE
        !$OMP PARALLEL DO PRIVATE( k, z_p )
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -162,4 +171,5 @@
 !-- Compute u* at the scalars' grid points
     !$OMP PARALLEL DO PRIVATE( a, b, k, uv_total, z_p )
+    !$acc kernels do
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -203,9 +213,13 @@
 !-- Values of us at ghost point locations are needed for the evaluation of usws 
 !-- and vsws.
+    !$acc update host( us )
     CALL exchange_horiz_2d( us )
+    !$acc update device( us )
+
 !
 !-- Compute u'w' for the total model domain.
 !-- First compute the corresponding component of u* and square it.
     !$OMP PARALLEL DO PRIVATE( a, b, k, rifm, z_p )
+    !$acc kernels do
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -245,4 +259,5 @@
 !-- First compute the corresponding component of u* and square it.
     !$OMP PARALLEL DO PRIVATE( a, b, k, rifm, z_p )
+    !$acc kernels do
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -285,4 +300,5 @@
 !--       For a given water flux in the Prandtl layer:
           !$OMP PARALLEL DO
+          !$acc kernels do
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -291,6 +307,8 @@
           ENDDO
           
-       ELSE          
+       ELSE
+          coupled_run = ( coupling_mode == 'atmosphere_to_ocean' .AND. run_coupled )
           !$OMP PARALLEL DO PRIVATE( a, b, k, z_p )
+          !$acc kernels do
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -302,6 +320,5 @@
 !--             Assume saturation for atmosphere coupled to ocean (but not
 !--             in case of precursor runs)
-                IF ( coupling_mode == 'atmosphere_to_ocean' .AND. run_coupled )&
-                THEN
+                IF ( coupled_run )  THEN
                    e_q = 6.1 * &
                         EXP( 0.07 * ( MIN(pt(0,j,i),pt(1,j,i)) - 273.15 ) )
@@ -334,7 +351,13 @@
 !-- Exchange the boundaries for the momentum fluxes (only for sake of 
 !-- completeness)
+    !$acc update host( usws, vsws )
     CALL exchange_horiz_2d( usws )
     CALL exchange_horiz_2d( vsws )
-    IF ( humidity  .OR.  passive_scalar )  CALL exchange_horiz_2d( qsws )
+    !$acc update device( usws, vsws )
+    IF ( humidity  .OR.  passive_scalar )  THEN
+       !$acc update host( qsws )
+       CALL exchange_horiz_2d( qsws )
+       !$acc update device( qsws )
+    ENDIF
 
 !
@@ -342,4 +365,5 @@
     IF ( .NOT. constant_heatflux )  THEN
        !$OMP PARALLEL DO
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -353,4 +377,5 @@
     IF ( .NOT. constant_waterflux .AND. ( humidity .OR. passive_scalar ) ) THEN
        !$OMP PARALLEL DO
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -364,4 +389,5 @@
     IF ( ibc_e_b == 2 )  THEN
        !$OMP PARALLEL DO
+       !$acc kernels do
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -375,4 +401,5 @@
     ENDIF
 
+    !$acc end data
 
  END SUBROUTINE prandtl_fluxes
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 1014)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -83,5 +83,5 @@
 
     PRIVATE
-    PUBLIC production_e, production_e_init
+    PUBLIC production_e, production_e_acc, production_e_init
 
     LOGICAL, SAVE ::  first_call = .TRUE.
@@ -94,4 +94,8 @@
     END INTERFACE production_e
     
+    INTERFACE production_e_acc
+       MODULE PROCEDURE production_e_acc
+    END INTERFACE production_e_acc
+
     INTERFACE production_e_init
        MODULE PROCEDURE production_e_init
